/*Index
	Compatibility Check				
	Action Menu Integration			
	Menu Layout						
	Functionality - General			
	Functionality - Bank Account	
	Functionality - Bank Loan		
	Functionality - Sell Shares
	Functionality - Buy Securities
	
*/

var FS_Pastract = {};
(function() {
	/* Compatibility Check */
	var BankNSEChecked = false;
	var balanceBMChecked = false;
	
	var BankNSECheck = function() {
		for (var a = 0; a < ModSupport.availableMods.length; a++) {
			var mod = ModSupport.availableMods[a];
			if((mod.id == "NSE" && mod.active) || (mod.id == "BMPASTRACT" && mod.active)) {
				$("body").append('<div id="CompMsg1" class="windowBorder errorWindow" style="z-index:7002;overflow:auto;display:none;"> <div class="windowTitle smallerWindowTitle">Warning</div>');
				$("#CompMsg1").append('<div style="margin-left:50px;width:400px;">Due to compatibility issues, you must disable either the Financial Services or the National Stock Exchange AND National Bank modification. If you decide to continue with the Financial Services modification, you are advised to withdraw all the money you have on the bank account in the National Bank modification. Please do so and restart the game.</div>');
				$("#CompMsg1").append('<br>');
				$("#CompMsg1").append('<div class="selectorButton whiteButton" onclick="window.close()" style="display:inline-block;margin-left:50px;width: 150px;">Quit Game</div>');
				$("#CompMsg1").append('<div class="selectorButton whiteButton" onclick="UI.toggleModsPanel()" style="display:inline-block;margin-left:50px;width: 150px;">Mods Menu</div>');
				GameManager.resume(false);
				$("#CompMsg1").gdDialog({
					popout: true,
					close: false
				});
				BankNSEChecked = true;
			}
		}
	};
	
	GDT.on(GDT.eventKeys.saves.loading, BankNSECheck);
	
	/* Action Menu Integration */
	var OriginalContextMenu = UI.showContextMenu;
    var NewContextMenu = function (items, mouseloc) {
    	items.push({
    		label: "Financial Services...",
    		action: function () {
    			Sound.click();
    			GameManager.resume(false);
    			$("#FS_Main").gdDialog({
    				popout: true,
    				close: true,
					onClose: function () {
						GameManager.resume(true);
					}
				});
				$(".tab").css({
					'display': 'inline-block',
					'width': '100%'
				});
				/*$(".tab-links").css({
					'border-bottom-style': 'solid'
				});*/
				$(".tab-links li").css({
					'list-style': 'none',
					'float': 'left',
					'margin': '0px 5px'
				});
				$(".tab-links li.active").css({
					'display': 'block',
					'background': '#797979'
				});
				$(".tab-links a").css({
					'display': 'inline-block',
					'padding': '9px 15px',
					'border-radius': '3px 3px 0px 0px',
					'transition': 'all linear 0.15s',
					'text-decoration': 'none',
					'border-style': 'solid',
					'border-width': '2px',
					'background': '#f6891d',
					'background-image': '-ms-linear-gradient(top, #FAA51A 0%, #F47A20 100%)',
					'background-image': '-webkit-linear-gradient(top, #FAA51A 0%, #F47A20 100%)'
				});
				$(".tab-links:after").css({
					'display': 'block',
					'clear': 'both',
					//'content': 'none'
				});
				$(".tab-content").css({
					//'z-index': '7005',
					'padding': '15px',
					'border-radius': '3px',
					'overflow': 'auto',
					'margin-top': '75px',
					//'position': 'relative',
					//'height': '75%',
					//'display': 'block',
					//'box-shadow': '-1px 1px 1px rgba(0,0,0,0.15)'
					'border-top-style': 'solid',
					'border-top-width': '1px'
				});
				$(".isTab").css({
					'display': 'none'
				});
				$(".isTab.active").css({
					'display': 'block',
					//'z-index': '7005'
				});
				$(".infoButton").css({
					'text-decoration': 'none',
					'border-style': 'solid',
					'border-width': '2px',
					'background': '#f6891d',
					'background-image': '-ms-linear-gradient(top, #FAA51A 0%, #F47A20 100%)',
					'background-image': '-webkit-linear-gradient(top, #FAA51A 0%, #F47A20 100%)'
				});
				$(".extraTallWindow").css({
					'width': '600px',
					'height': '800px'
				});
				$(".errorWindow").css({
					'width:': '500px',
					'height': '400px'
				});
				transferBalance();
				currentBalance();
				$("#FS_BankAccount").find("#FS_BankAccount_InputField").val(0)
				showInterestRate();
				displayInterestRate();
				displayLoanDuration();
				displayRepayLoanInformation();
				displayCreditRating();
				$("#FS_BankLoan_InputField").val(0)
				displayTotalAmount();
				displayAmountSold();
				displayTotalValueShares();
				displayShareValue();
				$("#FS_BuySecurities_GoldInputField").val(0);
				$("#FS_BuySecurities_SilverInputField").val(0);
				$("#FS_BuySecurities_OilInputField").val(0);
				$("#FS_BuySecurities_NSEInputField").val(0);
				displayPortfolioGold();
				displayPortfolioSilver();
				displayPortfolioOil();
				displayPortfolioNSE();
				displayPortfolioTotal();
			}
    	});
		OriginalContextMenu(items, mouseloc);			
    };
    UI.showContextMenu = NewContextMenu; 
	
	/* Menu Layout */
	$("body").append('<div id="FS_Main" class="windowBorder wideWindow tab" style="z-index:7002;overflow:auto;display:none;"> <div id="FS_Title" class="windowTitle smallerWindowTitle">Financial Services</div>');
	$("body").append('<div id="FS_Error" class="windowBorder smallWindow" style="z-index:8000;overflow:auto;display:none;"></div>');
	$("body").append('<div id="FS_InformationScreen" class="windowBorder tallWindow" style="z-index:8001;overflow:auto;display:none;"></div>');
	$("body").append('<div id="FS_PortfolioScreen" class="windowBorder tallWindow" style="z-index:8001;overflow:auto;display:none;"></div>');
	
	$("#FS_Error").append('<div id="FS_Error_Title" class="windowTitle smallerWindowTitle">Error</div>');
	$("#FS_Error").append('<br>');
	$("#FS_Error").append('<div id="FS_Error_Text" style="display:block;margin-left:25px;width:400px;text-align:center;"></div>');
	$("#FS_Error").append('<div id="FS_Error_OKButton" class="selectorButton orangeButton" onclick="UI.selectedOption(this)" style="z-index:8001;display:block;margin-left:125px;width:250px;">OK</div>');
	
	$("#FS_InformationScreen").append('<div id="FS_Information_Title" class="windowTitle smallerWindowTitle">Information</div>');
	$("#FS_InformationScreen").append('<br>');
	$("#FS_InformationScreen").append('<div id="FS_Information_Text" style="display:block;margin-left:25px;width:525px;"></div>');
	$("#FS_InformationScreen").append('<div id="FS_Information_OKButton" class="selectorButton orangeButton" onclick="UI.selectedOption(this)" style="display:block;margin-left:125px;width:350px;">OK</div>');
	
	$("#FS_PortfolioScreen").append('<div id="FS_Portfolio_Title" class="windowTitle smallerWindowTitle">Portfolio</div>');
	$("#FS_PortfolioScreen").append('<br>');
	$("#FS_PortfolioScreen").append('<div style="display:inline-block;margin-left:100px;width:50px;"><strong>ETF</strong></div><div style="display:inline-block;margin-left:100px;width:50px;"><strong>Amount</strong></div><div style="display:inline-block;margin-left:100px;width:50px;"><strong>Return</strong></div><br>');
	$("#FS_PortfolioScreen").append('<div style="display:inline-block;margin-left:100px;width:50px;">GLD</div><div id="FS_PortfolioScreen_GoldAmount" style="display:inline-block;margin-left:100px;width:50px;"></div><div id="FS_PortfolioScreen_GoldReturn" style="display:inline-block;margin-left:100px;width:50px;"></div>');
	$("#FS_PortfolioScreen").append('<div style="display:inline-block;margin-left:100px;width:50px;">SLV</div><div id="FS_PortfolioScreen_SilverAmount" style="display:inline-block;margin-left:100px;width:50px;"></div><div id="FS_PortfolioScreen_SilverReturn" style="display:inline-block;margin-left:100px;width:50px;"></div>');
	$("#FS_PortfolioScreen").append('<div style="display:inline-block;margin-left:100px;width:50px;">OIL</div><div id="FS_PortfolioScreen_OilAmount" style="display:inline-block;margin-left:100px;width:50px;"></div><div id="FS_PortfolioScreen_OilReturn" style="display:inline-block;margin-left:100px;width:50px;"></div>');
	$("#FS_PortfolioScreen").append('<div style="display:inline-block;margin-left:100px;width:50px;">NSE</div><div id="FS_PortfolioScreen_NSEAmount" style="display:inline-block;margin-left:100px;width:50px;"></div><div id="FS_PortfolioScreen_NSEReturn" style="display:inline-block;margin-left:100px;width:50px;"></div>');
	$("#FS_PortfolioScreen").append('<div style="display:inline-block;margin-left:100px;width:50px;"><strong>Total</strong></div><div id="FS_PortfolioScreen_TotalAmount" style="display:inline-block;margin-left:100px;width:50px;"></div><div id="FS_PortfolioScreen_TotalReturn" style="display:inline-block;margin-left:100px;width:50px;"></div>');
	$("#FS_PortfolioScreen").append('<div id="FS_PortfolioScreen_OKButton" class="selectorButton orangeButton" onclick="UI.selectedOption(this)" style="z-index:8001;display:block;margin-left:125px;width:250px;">OK</div>');
	
	$(function() {
		$("#FS_Main").tabs();
	});
	$("#FS_Main").append('<ul class="tab-links"><li class="active" title="Information"><a href="#FS_Information">Information</a></li><li title="Bank Account"><a href="#FS_BankAccount">Bank Account</a></li><li title="Bank Loan"><a href="#FS_BankLoan">Bank Loan</a></li><li title="Sell Shares"><a href="#FS_SellShares">Sell Shares</a></li><li title="Buy Securities"><a href="#FS_BuySecurities">Buy Securities</a></li>');
	$(".tab .tab-links a").on("click", function(e) {
		var currentAttrValue = $(this).attr('href');
         $('#FS_Main ' + currentAttrValue).show().siblings().hide();
		 $(this).parent('li').addClass('active').siblings().removeClass('active');
		 $("#FS_Main").show();
		 $("#FS_Title").show();
		 $(".tab-links").show();
		 e.preventDefault();
		 $("#FS_Title").html("Financial Services: " + $(".tab-links li.active").attr('title'));
	});
	$("#FS_Main").append('<div id="FS_Information" class="tab-content isTab active" style="text-align:center;margin:15px;">Welcome to the Financial Services Information screen!<br><br>From here you can select a tab to get to the screen of your desired action. It is very important that you do not have the mods National Bank and National Stock Exchange currently installed. Also, please do bare in mind that this mod is still work-in-progress. It would therefor be appreciated if all bugs encountered are reported.<br><br>If you choose the Bank Account tab, you can access your company&#39;s bank account and deposit or withdraw money to/from it.<br><br>On the Bank Loan screen, you can apply for a loan from the bank, in case you&#39;re ever running low on funds.<br><br>You can also sell your company&#39;s shares by selecting the Sell Shares tab.<br><br>By selecting the Buy Securities tab, you can raise money by buying securities such as bonds and futures.</div>');
	$("#FS_Main").append('<div id="FS_BankAccount" class="tab-content isTab"></div>');
	$("#FS_Main").append('<div id="FS_BankLoan" class="tab-content isTab"></div>');
	$("#FS_Main").append('<div id="FS_SellShares" class="tab-content isTab"></div>');
	$("#FS_Main").append('<div id="FS_BuySecurities" class="tab-content isTab"></div>');
	
	$("#FS_BankAccount").append('<div id="FS_BankAccount_Balance" style="text-align:center;margin-left:50px;width:700px"></div>');
	$("#FS_BankAccount").append('<div id="FS_BankAccount_Interest" style="text-align:center;margin-left:50px;width:700px"></div>');
	$("#FS_BankAccount").append('<br>');
	$("#FS_BankAccount").append('<div id="FS_BankAccount_Decrease10Percent" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;position:relative;margin-left:50px;width:150px;">-10%</div>');
	$("#FS_BankAccount").append('<input id="FS_BankAccount_InputField" type="number" style="display:inline-block;margin-left:25px;width:300px"></input>');
	$("#FS_BankAccount").append('<div id="FS_BankAccount_Increase10Percent" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;position:relative;margin-left:25px;width:150px;">+10%</div>');
	$("#FS_BankAccount").append('<div id="FS_BankAccount_Withdraw" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;margin-left:100px;width:250px">Withdraw Money</div>');	
	$("#FS_BankAccount").append('<div id="FS_BankAccount_Deposit" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;margin-left:50px;width:250px">Deposit Money</div>');	
	
	$("#FS_BankLoan").append('<div id="FS_BankLoan_Interest" style="text-align:center;margin-left:50px;width:700px"></div>');
	$("#FS_BankLoan").append('<div id="FS_BankLoan_Duration" style="text-align:center;margin-left:50px;width:700px"></div>');
	$("#FS_BankLoan").append('<div id="FS_BankLoan_CreditRating" style="text-align:center;margin-left:50px;width:700px"></div>');
	$("#FS_BankLoan").append('<br>');
	$("#FS_BankLoan").append('<div style="text-align:center;margin-left:50px;width:700px">Enter amount to loan from the bank</div>');
	$("#FS_BankLoan").append('<input id="FS_BankLoan_InputField" type="number" style="display:block;margin-left:100px;width:550px;"></input>');
	$("#FS_BankLoan").append('<div id="FS_BankLoan_ApplyLoanButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:block;margin-left:200px;width:350px;">Apply for Loan</div>');
	$("#FS_BankLoan").append('<br>');
	$("#FS_BankLoan").append('<br>');
	$("#FS_BankLoan").append('<div id="FS_BankLoan_RepayLoanInformation" style="text-align:center;margin-left:50px;width:700px;"></div>');
	$("#FS_BankLoan").append('<div id="FS_BankLoan_RepayLoanButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:block;margin-left:150px;width:450px;">Repay Loan</div>');
	$("#FS_BankLoan").append('<div id="FS_BankLoan_CreditRatingInformation" class="selectorButton infoButton" onclick="UI.selectedOption(this)" style="display:block;margin-left:150px;width:450px;">Credit Rating Information</div>');
	
	$("#FS_SellShares").append('<div id="FS_SellShares_AmountAbleToSell" style="text-align:center;margin-left:50px;width:700px;"></div>');
	$("#FS_SellShares").append('<div id="FS_SellShares_AmountSold" style="text-align:center;margin-left:50px;width:700px;"></div>');
	$("#FS_SellShares").append('<div id="FS_SellShares_ShareValue" style="text-align:center;margin-left:50px;width:700px;"></div>');
	$("#FS_SellShares").append('<br>');
	$("#FS_SellShares").append('<div style="text-align:center;margin-left:50px;width:700px;">Please enter the amount of shares you would like to sell.</div>');
	$("#FS_SellShares").append('<input id="FS_SellShares_InputField" type="number" style="display:block;margin-left:100px;width:550px;"></input>');
	$("#FS_SellShares").append('<div id="FS_SellShares_SellShareButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:block;margin-left:150px;width:450px;">Sell Shares</div>');
	$("#FS_SellShares").append('<br>');
	$("#FS_SellShares").append('<div id="FS_SellShares_TotalValueShares" style="text-align:center;margin-left:50px;width:700px;"></div>');
	$("#FS_SellShares").append('<div id="FS_SellShares_BuyAllShareButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:block;margin-left:150px;width:450px;">Buy All Shares Back</div>');
	$("#FS_SellShares").append('<div id="FS_SellShares_SharesInformation" class="selectorButton infoButton" onclick="UI.selectedOption(this)" style="display:block;margin-left:150px;width:450px;">Shares Information</div>');
	
	$("#FS_BuySecurities").append('<div id="FS_BuySecurities_InformationButton" class="selectorButton infoButton" onclick="UI.selectedOption(this)" style="display:inline-block;width:250px;margin-left:100px">Information</div> <div id="FS_BuySecurities_PortfolioButton" class="selectorButton infoButton" onclick="UI.selectedOption(this)" style="display:inline-block;width:250px;margin-left:50px;">Portfolio</div><br>');
	$("#FS_BuySecurities").append('<div style="display:inline-block;margin-left:50px;width:50px;"><strong>ETF</strong></div><div style="display:inline-block;margin-left:25px;width:50px;"><strong>Price</strong></div><div style="display:inline-block;margin-left:25px;width:25px;"><strong>Growth</strong></div><div style="display:inline-block;margin-left:50px;width:200px;"><strong>Enter amount</strong></div><br>');
	$("#FS_BuySecurities").append('<div style="display:inline-block;margin-left:50px;width:50px;">GLD</div> <div id="FS_BuySecurities_GoldPrice" style="display:inline-block;margin-left:25px;width:50px;"></div> <div id="FS_BuySecurities_GoldGrowth" style="display:inline-block;margin-left:25px;width:25px;"></div> <input id="FS_BuySecurities_GoldInputField" type="number" style="display:inline-block;margin-left:25px;width:200px;"></input><div id="FS_BuySecurities_BuyGoldButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;margin-left:25px;width:100px;">Buy</div>  <div id="FS_BuySecurities_SellGoldButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;margin-left:10px;width:100px;">Sell</div><br>');
	$("#FS_BuySecurities").append('<div style="display:inline-block;margin-left:50px;width:50px;">SLV</div> <div id="FS_BuySecurities_SilverPrice" style="display:inline-block;margin-left:25px;width:50px;"></div> <div id="FS_BuySecurities_SilverGrowth" style="display:inline-block;margin-left:25px;width:25px;"></div> <input id="FS_BuySecurities_SilverInputField" type="number" style="display:inline-block;margin-left:25px;width:200px;"></input><div id="FS_BuySecurities_BuySilverButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;margin-left:25px;width:100px;">Buy</div> <div id="FS_BuySecurities_SellSilverButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;margin-left:10px;width:100px;">Sell</div><br>');
	$("#FS_BuySecurities").append('<div style="display:inline-block;margin-left:50px;width:50px;">OIL</div> <div id="FS_BuySecurities_OilPrice" style="display:inline-block;margin-left:25px;width:50px;"></div> <div id="FS_BuySecurities_OilGrowth" style="display:inline-block;margin-left:25px;width:25px;"></div> <input id="FS_BuySecurities_OilInputField" type="number" style="display:inline-block;margin-left:25px;width:200px;"></input><div id="FS_BuySecurities_BuyOilButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;margin-left:25px;width:100px;">Buy</div> <div id="FS_BuySecurities_SellOilButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;margin-left:10px;width:100px;">Sell</div><br>');
	$("#FS_BuySecurities").append('<div style="display:inline-block;margin-left:50px;width:50px;">NSE</div> <div id="FS_BuySecurities_NSEPrice" style="display:inline-block;margin-left:25px;width:50px;"></div> <div id="FS_BuySecurities_NSEGrowth" style="display:inline-block;margin-left:25px;width:25px;"></div> <input id="FS_BuySecurities_NSEInputField" type="number" style="display:inline-block;margin-left:25px;width:200px;"></input><div id="FS_BuySecurities_BuyNSEButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;margin-left:25px;width:100px;">Buy</div> <div id="FS_BuySecurities_SellNSEButton" class="selectorButton whiteButton" onclick="UI.selectedOption(this)" style="display:inline-block;margin-left:10px;width:100px;">Sell</div><br>');
	
	/* Functionality */
		/* General */
	
	UI.selectedOption = function (a) {
		Sound.click();
		switch(a.id) {
			case "FS_Error_OKButton":
				$("#FS_Error").dialog('close');
				break;
			case "FS_Information_OKButton":
				$("#FS_InformationScreen").dialog('close');
				break;
			case "FS_PortfolioScreen_OKButton":
				$("#FS_PortfolioScreen").dialog('close');
				break;
			case "FS_BankAccount_Decrease10Percent":
				changeInputValueAccount(true);
				break;
			case "FS_BankAccount_Increase10Percent":
				changeInputValueAccount(false);
				break;
			case "FS_BankAccount_Withdraw":
				withdrawMoney();
				break;
			case "FS_BankAccount_Deposit":
				depositMoney();
				break;
			case "FS_BankLoan_ApplyLoanButton":
				applyLoan();
				break;
			case "FS_BankLoan_RepayLoanButton":
				repayLoanAll();
				break;
			case "FS_BankLoan_CreditRatingInformation":
				displayCreditRatingInformation();
				break;
			case "FS_SellShares_SharesInformation":
				displaySharesInformation();
				break;
			case "FS_SellShares_SellShareButton":
				sellShares();
				break;
			case "FS_SellShares_BuyAllShareButton":
				buyAllShares();
				break;
			case "FS_BuySecurities_BuyGoldButton":
				buyGold();
				break;
			case "FS_BuySecurities_BuySilverButton":
				buySilver();
				break;
			case "FS_BuySecurities_BuyOilButton":
				buyOil();
				break;
			case "FS_BuySecurities_BuyNSEButton":
				buyNSE();
				break;
			case "FS_BuySecurities_SellGoldButton":
				sellGold();
				break;
			case "FS_BuySecurities_SellSilverButton":
				sellSilver();
				break;
			case "FS_BuySecurities_SellOilButton":
				sellOil();
				break;
			case "FS_BuySecurities_SellNSEButton":
				sellNSE();
				break;
			case "FS_BuySecurities_InformationButton":
				displaySecuritiesInformation();
				break;
			case "FS_BuySecurities_PortfolioButton":
				displaySecuritiesPortfolio();
				break;
			default:
				return;
		}
	}
	
		/* Bank Account */
		
	var transferBalance = function() {
		if (GDT.getDataStore("BankMod").data.CB > 0 && balanceBMChecked == false) {
			GDT.getDataStore("FSMPASTRACT").data.CB += GDT.getDataStore("BankMod").data.CB;
			GDT.getDataStore("BankMod").data.CB = 0;
			balanceBMChecked = true;
		}
	}
	
	var currentBalance = function() {
		var GDSdataCB = parseInt(GDT.getDataStore("FSMPASTRACT").data.CB);
		if (isNaN(GDSdataCB) || GDSdataCB == 'undefined' || GDSdataCB == 0) {
			GDT.getDataStore("FSMPASTRACT").data.CB, GDSdataCB = 0;
			$("#FS_BankAccount").find("#FS_BankAccount_Balance").html("Current Bank Balance: " + GDSdataCB);
		}
		else if (GDSdataCB >= 1E3 && GDSdataCB < 1E6) {
			$("#FS_BankAccount").find("#FS_BankAccount_Balance").html("Current Bank Balance: " + (GDSdataCB/1E3).toFixed(1) + "K");
		}
		else if (GDSdataCB >= 1E6 && GDSdataCB < 1E9) {
			$("#FS_BankAccount").find("#FS_BankAccount_Balance").html("Current Bank Balance: " + (GDSdataCB/1E6).toFixed(1) + "M");
		}
		else if (GDSdataCB >= 1E9) {
			$("#FS_BankAccount").find("#FS_BankAccount_Balance").html("Current Bank Balance: " + (GDSdataCB/1E9).toFixed(1) + "B");
		}
		else {
			$("#FS_BankAccount").find("#FS_BankAccount_Balance").html("Current Bank Balance: " + Math.round(GDSdataCB));
		}
	}
	
	var changeInputValueAccount = function(value) {
		var a = parseInt($("#FS_BankAccount").find("#FS_BankAccount_InputField").val());
		var b = parseInt(GDT.getDataStore("FSMPASTRACT").data.CB);
		var c = value;
		var d;
		if (value == true) {
			 d = a - Math.floor(b / 10);
			if (d < 0) {
				d = 0;
			}
		}
		else if (value == false) {
			d = a + Math.floor(b / 10);
			if (d > b) {
				d = b;
			}
		}
		$("#FS_BankAccount").find("#FS_BankAccount_InputField").val(d)
	};
	
	var withdrawMoney = function() {
		var a = parseInt($("#FS_BankAccount").find("#FS_BankAccount_InputField").val());
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.CB) || GDT.getDataStore("FSMPASTRACT").data.CB == 0) {
			GDT.getDataStore("FSMPASTRACT").data.CB = 0;
		};
		
		if (a <= 0 || isNaN(a)) {
			$("#FS_Error").gdDialog({
				popout: true,
				close: true
			});
			$("#FS_Error_Text").html("You must enter a valid number (higher than 0).<br><br><br>");
			$("#FS_BankAccount").find("#FS_BankAccount_InputField").val(0)
		}
		else if (a > parseInt(GDT.getDataStore("FSMPASTRACT").data.CB)) {
			$("#FS_Error").gdDialog({
				popout: true,
				close: true
			});
			$("#FS_Error_Text").html("You tried to withdraw more money than you currently have. If you are in desperate need for extra cash, you may want to consider taking a loan.<br><br><br>");
			$("#FS_BankAccount").find("#FS_BankAccount_InputField").val(0)
		}
		else {
			$("#FS_Main").dialog("close");
			GDT.getDataStore("FSMPASTRACT").data.CB -= a;
			GameManager.company.adjustCash(a, "Money Withdrawal");
			
		}
	};

	var depositMoney = function() {
		var a = parseInt($("#FS_BankAccount_InputField").val());
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.CB) || GDT.getDataStore("FSMPASTRACT").data.CB == 0) {
			GDT.getDataStore("FSMPASTRACT").data.CB = 0;
		};
		
		if (a <= 0 || isNaN(a)) {
			$("#FS_Error").gdDialog({
				popout: true,
				close: true
			});
			$("#FS_Error_Text").html("You must enter a valid number (higher than 0).<br><br><br>");
			$("#FS_BankAccount").find("#FS_BankAccount_InputField").val(0)
		}
		else if (a > GameManager.company.cash) {
			$("#FS_Error").gdDialog({
				popout: true,
				close: true
			});
			$("#FS_Error_Text").html("You tried to deposit more money than you currently have.<br><br><br>");
			$("#FS_BankAccount").find("#FS_BankAccount_InputField").val(0)
		}
		else {
			$("#FS_Main").dialog("close");
			GDT.getDataStore("FSMPASTRACT").data.CB += a;
			GameManager.company.adjustCash(-a, "Money Deposit");
		}
	};
	
	var showInterestRate = function() {
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.IRB)) {
			GDT.getDataStore("FSMPASTRACT").data.IRB = 2;
		}
		$("#FS_BankAccount_Interest").html("Annual interest rate (compounded quarterly): " + GDT.getDataStore("FSMPASTRACT").data.IRB + "%");
	}
	
	var payInterest = function() {
		if (GDT.getDataStore("FSMPASTRACT").data.CB > 0) {
			var e = GameManager.company.getDate(GameManager.company.currentWeek);
			if ((e.month == 1 || e.month == 4 || e.month == 7 || e.month == 10) && e.week == 1) {
				var f = GDT.getDataStore("FSMPASTRACT").data.CB * (GDT.getDataStore("FSMPASTRACT").data.IRB / 100 / 4);
				GameManager.company.cashLog.push({
						amount: f,
						label: "Bank Interest"
					});
				GDT.getDataStore("FSMPASTRACT").data.CB += f
			}
		}
	};	
	GDT.on(GDT.eventKeys.gameplay.weekProceeded, payInterest);
	
		/* Bank Loan */
	
	var displayInterestRate = function() {
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.IRL)) {
			GDT.getDataStore("FSMPASTRACT").data.IRL = 4;
		}
		$("#FS_BankLoan_Interest").html("Current interest rate: " + GDT.getDataStore("FSMPASTRACT").data.IRL + "%");
	};
	
	var displayLoanDuration = function() {
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.LD)) {
			GDT.getDataStore("FSMPASTRACT").data.LD = 10;
		}
		$("#FS_BankLoan_Duration").html("Loan duration: " + GDT.getDataStore("FSMPASTRACT").data.LD + " years");
	}
	
	var displayRepayLoanInformation = function() {
		if (GDT.getDataStore("FSMPASTRACT").data.HL == 'undefined') {
			GDT.getDataStore("FSMPASTRACT").data.HL = false;
		}
		if (GDT.getDataStore("FSMPASTRACT").data.HL == false) {
			$("#FS_BankLoan_RepayLoanInformation").html("You currently do not have a loan with the bank.");
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.HL == true) {
			var o = GDT.getDataStore("FSMPASTRACT").data.CLA;
			if (o >= 1E3 && o < 1E6) {
				var g = "K ";
				var n = 1E3;
			}
			else if (o >= 1E6 && o < 1E9) {
				var g = "M ";
				var n = 1E6;
			}
			else if (o >= 1E9) {
				var g = "B ";
				var n = 1E9;
			}
			else {
				var g = " ";
				var n = 1;
			}
			$("#FS_BankLoan_RepayLoanInformation").html("You currently have a loan with the bank. You have to pay " + (GDT.getDataStore("FSMPASTRACT").data.CLA / n).toFixed(1) + g + "over the course of " + GDT.getDataStore("FSMPASTRACT").data.LD + " years");
			if (GDT.getDataStore("FSMPASTRACT").data.HL == true) {
				$("#FS_BankLoan_RepayLoanButton").html("Repay Loan (" + (GDT.getDataStore("FSMPASTRACT").data.CLA / n).toFixed(1) + g +")");
			}
			else {
				$("#FS_BankLoan_RepayLoanButton").html("Repay Loan");
			}
		}
	};
	
	var displayCreditRating = function() {
		var h = GameManager.company.cash + parseInt(GDT.getDataStore("FSMPASTRACT").data.CB);
		var i = GameManager.company.currentLevel;
		if (h < 1E6 && i == 4) {
			GDT.getDataStore("FSMPASTRACT").data.CR = "C";
		}
		else if ((h < 1E5 && i == 1) || (h < 1E6 && (i == 2 || i == 3)) || (h >= 1E6 && h < 5E6 && i == 4)) {
			GDT.getDataStore("FSMPASTRACT").data.CR = "CCC";
		}
		else if ((h >= 1E5 && h < 3E5 && i == 1) || (h >= 1E6 && h < 5E6 && (i == 2 || i == 3)) || (h >= 5E6 && h < 1E7 && i == 4)) {
			GDT.getDataStore("FSMPASTRACT").data.CR = "B";
		}
		else if ((h >= 3E5 && h < 7E5 && i == 1) || (h >= 5E6 && h < 1E7 && (i == 2 || i == 3)) || (h >= 1E7 && h < 5E7 && i == 4)) {
			GDT.getDataStore("FSMPASTRACT").data.CR = "BBB";
		}
		else if ((h >= 7E5 && i == 1) || (h >= 1E7 && h < 3E7 && (i == 2 || i == 3)) || (h >= 5E7 && h < 1E8 && i == 4)) {
			GDT.getDataStore("FSMPASTRACT").data.CR = "A";
		}
		else if ((h > 3E7 && (i == 2 || i == 3)) || (h > 1E8 && i == 4)) {
			GDT.getDataStore("FSMPASTRACT").data.CR = "AAA";
		}
		$("#FS_BankLoan_CreditRating").html("Credit Rating: " + GDT.getDataStore("FSMPASTRACT").data.CR);
	}
	
	var displayCreditRatingInformation = function() {
		$("#FS_InformationScreen").gdDialog({
			popout: true,
			close: true,
		});
		$("#FS_Information_Text").html("This strongly simplified credit rating system is vital for the way the loan system works. The credit rating of your company is an indication of the financial health of your company, meaning a low credit rating signifies an unhealthy company, resulting in the fact that you may only get a small loan.<br><br>The credit ratings in ascending order are:<ul><li><strong>C</strong> - Companies with this rating are only able to get a loan up to 50% of their current capital.</li><li><strong>CCC</strong> - Companies with this rating are able to get a loan up to 75% of their current capital.</li><li><strong>B</strong> - Companies with this rating are able to get a loan up to 100% of their current capital.</li><li><strong>BBB</strong> - Companies with this rating are able to get a loan up to 150% of their current capital.</li><li><strong>A</strong> - Companies with this rating are able to get a loan up to 200% of their current capital.</li><li><strong>AAA</strong> - Companies with this rating are able to get a loan up to 250% of their current capital.</li></ul>Current capital of a company is the sum of the amount of cash and bank deposit a company has.<br><br>This current rating system is only experimental and subject to review.");
	}
	var applyLoan = function() {
		if (GDT.getDataStore("FSMPASTRACT").data.HL == true) {
			$("#FS_Error").gdDialog({
				popout: true,
				close: true
			});
			$("#FS_Error_Title").html("Bank Loan");
			$("#FS_Error_Text").html("We're sorry, but you may only have one loan at a time. Consider paying off your previous loan and taking out an other loan or raise funds by selling shares.");
		}
		else {
			var k = parseInt($("#FS_BankLoan_InputField").val());
			var l = parseInt(GameManager.company.cash) + parseInt(GDT.getDataStore("FSMPASTRACT").data.CB);
			if (l >= 1E3 && l < 1E6) {
				var j = "K ";
				var m = 1E3;
			}
			else if (l >= 1E6 && l < 1E9) {
				var j = "M ";
				var m = 1E6;
			}
			else if (l > 1E9) {
				var j = "B ";
				var m = 1E9;
			}
			else {
				var j = " ";
				var m = 1;
			}
			
			if (isNaN(k) || k <= 0) {
				$("#FS_Error").gdDialog({
					popout: true,
					close: true
				});
				$("#FS_Error_Text").html("You must enter a valid number (higher than 0).<br><br><br>");
			}
			else if (GDT.getDataStore("FSMPASTRACT").data.CR == "C" && k > 0.5 * l) {
				$("#FS_Error").gdDialog({
					popout: true,
					close: true
				});
				$("#FS_Error_Title").html("Bank Loan");
				$("#FS_Error_Text").html("We're sorry, but you may not loan this much. You may only take a loan up to " + ((0.5 * l) / m).toFixed(1) + j);
			}
			else if (GDT.getDataStore("FSMPASTRACT").data.CR == "CCC" && k > 0.75 * l) {
				$("#FS_Error").gdDialog({
					popout: true,
					close: true
				});
				$("#FS_Error_Title").html("Bank Loan");
				$("#FS_Error_Text").html("We're sorry, but you may not loan this much. You may only take a loan up to " + ((0.75 * l) / m).toFixed(1) + j);
			}
			else if (GDT.getDataStore("FSMPASTRACT").data.CR == "B" && k > 1 * l) {
				$("#FS_Error").gdDialog({
					popout: true,
					close: true
				});
				$("#FS_Error_Title").html("Bank Loan");
				$("#FS_Error_Text").html("We're sorry, but you may not loan this much. You may only take a loan up to " + ((1 * l) / m).toFixed(1) + j);
			}
			else if (GDT.getDataStore("FSMPASTRACT").data.CR == "BBB" && k > 1.5 * l) {
				$("#FS_Error").gdDialog({
					popout: true,
					close: true
				});
				$("#FS_Error_Title").html("Bank Loan");
				$("#FS_Error_Text").html("We're sorry, but you may not loan this much. You may only take a loan up to " + ((1.5 * l) / m).toFixed(1) + j);
			}
			else if (GDT.getDataStore("FSMPASTRACT").data.CR == "A" && k > 2 * l) {
				$("#FS_Error").gdDialog({
					popout: true,
					close: true
				});
				$("#FS_Error_Title").html("Bank Loan");
				$("#FS_Error_Text").html("We're sorry, but you may not loan this much. You may only take a loan up to " + ((2 * l) / m).toFixed(1) + j);
			}
			else if (GDT.getDataStore("FSMPASTRACT").data.CR == "AAA" && k > 2.5 * l) {
				$("#FS_Error").gdDialog({
					popout: true,
					close: true
				});
				$("#FS_Error_Title").html("Bank Loan");
				$("#FS_Error_Text").html("We're sorry, but you may not loan this much. You may only take a loan up to " + ((2.5 * l) / m).toFixed(1) + j);
			}
			else {
				GDT.getDataStore("FSMPASTRACT").data.HL = true;
				GDT.getDataStore("FSMPASTRACT").data.CLA = k * (GDT.getDataStore("FSMPASTRACT").data.IRL / 100 + 1);
				GDT.getDataStore("FSMPASTRACT").data.TLA = k * (GDT.getDataStore("FSMPASTRACT").data.IRL / 100 + 1);
				GameManager.company.adjustCash(k, "Bank Loan");
				$("#FS_Main").dialog('close');
			}
		}
	};
	
	var repayLoan = function() {
		if (GDT.getDataStore("FSMPASTRACT").data.HL == true) {
			var q = GameManager.company.getDate(GameManager.company.currentWeek);
			GDT.getDataStore("FSMPASTRACT").data.LRY = GDT.getDataStore("FSMPASTRACT").data.TLA / GDT.getDataStore("FSMPASTRACT").data.LD
			if (GDT.getDataStore("FSMPASTRACT").data.CLA > 0 && (q.week == 1 && q.month == 1)) {
				GDT.getDataStore("FSMPASTRACT").data.CLA -= GDT.getDataStore("FSMPASTRACT").data.LRY;
				GameManager.company.adjustCash(-GDT.getDataStore("FSMPASTRACT").data.LRY, "Loan repayment");
				if (GDT.getDataStore("FSMPASTRACT").data.CLA == 0) {
					GDT.getDataStore("FSMPASTRACT").data.HL == false;
					GDT.getDataStore("FSMPASTRACT").data.TLA = 0;
				}
			}
		}
	};
	GDT.on(GDT.eventKeys.gameplay.weekProceeded, repayLoan);
	
	var repayLoanAll = function() {
		if (GDT.getDataStore("FSMPASTRACT").data.HL == false) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You do not have a loan to pay back.");
		}
		else {
			if (GDT.getDataStore("FSMPASTRACT").data.CLA > (GameManager.company.cash + GDT.getDataStore("FSMPASTRACT").data.CB)) {
				$("#FS_Error").gdDialog({
					popout: true,
					close: true
				});
				$("#FS_Error_Title").html("Error");
				$("#FS_Error_Text").html("You do not have the funds to pay this loan back.");
			}
			else if (GDT.getDataStore("FSMPASTRACT").data.CLA > GameManager.company.cash) {
				GDT.getDataStore("FSMPASTRACT").data.CB -= GDT.getDataStore("FSMPASTRACT").data.CLA;
				GDT.getDataStore("FSMPASTRACT").data.HL = false;
				GameManager.company.cashLog.push({
					amount: GDT.getDataStore("FSMPASTRACT").data.CLA,
					label: "Loan repayment"
				});
				GDT.getDataStore("FSMPASTRACT").data.CLA = 0;
				GDT.getDataStore("FSMPASTRACT").data.TLA = 0;
				$("#FS_BankLoan_RepayLoanButton").html("Repay Loan");
				$("#FS_Main").dialog("close");
			}
			else {
				GameManager.company.adjustCash(-GDT.getDataStore("FSMPASTRACT").data.CLA, "Loan Repayment");
				GDT.getDataStore("FSMPASTRACT").data.HL = false;
				GDT.getDataStore("FSMPASTRACT").data.CLA = 0;
				GDT.getDataStore("FSMPASTRACT").data.TLA = 0;
				$("#FS_BankLoan_RepayLoanButton").html("Repay Loan");
				$("#FS_Main").dialog("close");
			}
		}
	}
	
		/* Sell Shares */
		
	var displayTotalAmount = function() {
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.TAS)) {
			GDT.getDataStore("FSMPASTRACT").data.TAS = 1E6;
		}
		if (GDT.getDataStore("FSMPASTRACT").data.TAS >= 1E3 && GDT.getDataStore("FSMPASTRACT").data.TAS < 1E6) {
			var s = "K ";
			var t = 1E3;
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.TAS >= 1E6 && GDT.getDataStore("FSMPASTRACT").data.TAS < 1E9) {
			var s = "M ";
			var t = 1E6;
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.TAS >= 1E9) { 
			var s = "B ";
			var t = 1E6;
		}
		else {
			var s = " ";
			var t = 1;
		}
		$("#FS_SellShares_AmountAbleToSell").html("Total amount of shares able to sell: " + (GDT.getDataStore("FSMPASTRACT").data.TAS / t).toFixed(1) + s);
	}
	
	var displayAmountSold = function() {
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.ASS)) {
			GDT.getDataStore("FSMPASTRACT").data.ASS = 0;
		}
		if (GDT.getDataStore("FSMPASTRACT").data.ASS >= 1E3 && GDT.getDataStore("FSMPASTRACT").data.ASS < 1E6) {
			var u = "K ";
			var v = 1E3;
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.ASS >= 1E6 && GDT.getDataStore("FSMPASTRACT").data.ASS < 1E9) {
			var u = "M ";
			var v = 1E6;
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.ASS >= 1E9) { 
			var u = "B ";
			var v = 1E6;
		}
		else {
			var u = " ";
			var v = 1;
		}
		$("#FS_SellShares_AmountSold").html("Amount of shares sold: " + (GDT.getDataStore("FSMPASTRACT").data.ASS / v).toFixed(1) + u);
	}
	
	var displayTotalValueShares = function() {
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.TVS)) {
			GDT.getDataStore("FSMPASTRACT").data.TVS = 0;
		}
		if (GDT.getDataStore("FSMPASTRACT").data.TVS >= 1E3 && GDT.getDataStore("FSMPASTRACT").data.TVS < 1E6) {
			var w = "K ";
			var x = 1E3;
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.TVS >= 1E6 && GDT.getDataStore("FSMPASTRACT").data.TVS < 1E9) {
			var w = "M ";
			var x = 1E6;
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.TVS >= 1E9) { 
			var w = "B ";
			var x = 1E6;
		}
		else {
			var w = " ";
			var x = 1;
		}
		$("#FS_SellShares_TotalValueShares").html("Value of all shares sold: " + (GDT.getDataStore("FSMPASTRACT").data.TVS / x).toFixed(1) + w);
	}
	
	var displayShareValue = function() {
		if (GameManager.company.currentLevel == 1) {
			var y = 0.05;
		}
		else if (GameManager.company.currentLevel == 2) {
			var y = 0.4;
		}
		else if (GameManager.company.currentLevel == 3) {
			var y = 0.6;
		}
		else if (GameManager.company.currentLevel == 4) {
			var y = 1;
		};
		
		if (GDT.getDataStore("FSMPASTRACT").data.CR == "AAA") {
			var z = 25;
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.CR == "A") {
			var z = 20;
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.CR == "BBB") {
			var z = 15;
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.CR == "B") {
			var z = 10;
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.CR == "CCC") {
			var z = 5;
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.CR == "C") {
			var z = 0;
		}
		
		GDT.getDataStore("FSMPASTRACT").data.SV = (z + parseInt(GameManager.company.staff.length) + parseInt(GameManager.company.gameLog.length) / 15) * y;
		$("#FS_SellShares_ShareValue").html("Value per share: " + (GDT.getDataStore("FSMPASTRACT").data.SV).toFixed(1));
	}
	
	var displaySharesInformation = function() {
		$("#FS_InformationScreen").gdDialog({
			popout: true,
			close: true,
		});
		$("#FS_Information_Text").html("By selling shares you are able to raise funds immediately. However, you are required to pay the shareholders dividend (20% of the yearly profit) every year.<br><br>The total amount of shares able to be sold indicates the maximum amount of shares that you are able to sell. It would be wise to not sell all of these at once, as the amount only changes by random occuring events.<br><br>The value of each share is determined by a number of things: credit rating, amount of employees, amount of games sold and the level are you currently in. The algorithm used is subject to review and may change many times over the course of some updates.<br><br> It is possible to buy all the shares back. This is a very pricey action to undertake as the shares will most likely have risen in value. Doing this will prevent you from paying dividend and enable you to sell more shares. ");
	};
	
	var sellShares = function() {
		var aa = parseInt($("#FS_SellShares_InputField").val());
		if (aa > (GDT.getDataStore("FSMPASTRACT").data.TAS - GDT.getDataStore("FSMPASTRACT").data.ASS)) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You cannot sell that many shares.");
		}
		else if (aa <= 0 || isNaN(aa)) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("Please enter a valid number (higher than 0).");
		}
		else {
			$("#FS_Main").dialog('close');
			GDT.getDataStore("FSMPASTRACT").data.ASS += aa;
			GDT.getDataStore("FSMPASTRACT").data.TVS += aa * GDT.getDataStore("FSMPASTRACT").data.SV;
			GameManager.company.adjustCash(GDT.getDataStore("FSMPASTRACT").data.TVS, "Issued Shares");
		}
	}		
	
	var buyAllShares = function() {
		var bb = GameManager.company.cash + parseInt(GDT.getDataStore("FSMPASTRACT").data.CB);
		if (GDT.getDataStore("FSMPASTRACT").data.ASS == 0) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You have no shares to buy back.");
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.TVS > bb) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You do not have the funds to make this transaction.");
		}
		else if (GDT.getDataStore("FSMPASTRACT").data.TVS > GameManager.company.cash && GDT.getDataStore("FSMPASTRACT").data.TVS <= parseInt(GDT.getDataStore("FSMPASTRACT").data.CB)) {
			$("#FS_Main").dialog('close');
			GDT.getDataStore("FSMPASTRACT").data.CB -= GDT.getDataStore("FSMPASTRACT").data.TVS;
			GDT.getDataStore("FSMPASTRACT").data.ASS = 0;
			GDT.getDataStore("FSMPASTRACT").data.TVS = 0;
		}
		else {
			$("#FS_Main").dialog('close');
			GameManager.company.adjustCash(-GDT.getDataStore("FSMPASTRACT").data.TVS, "Repurchased Shares");
			GDT.getDataStore("FSMPASTRACT").data.ASS = 0;
			GDT.getDataStore("FSMPASTRACT").data.TVS = 0;
		}
	}
	
	var updateTotalShareValue = function() {
		if (GameManager.company.getDate(GameManager.company.currentWeek).week == 1) {
			GDT.getDataStore("FSMPASTRACT").data.TVS = GDT.getDataStore("FSMPASTRACT").data.ASS * GDT.getDataStore("FSMPASTRACT").data.SV;
		}
	}
	GDT.on(GDT.eventKeys.gameplay.weekProceeded, updateTotalShareValue);
	
	var payDividend = function(FSMPASTRACT) {
		if (GameManager.company.getDate(GameManager.company.currentWeek).week == 2 && GameManager.company.getDate(GameManager.company.currentWeek).month == 1) {
			GDT.getDataStore("FSMPASTRACT").data.YPA = parseInt(GameManager.company.cash);
		}
		if (GameManager.company.getDate(GameManager.company.currentWeek).week == 1 && GameManager.company.getDate(GameManager.company.currentWeek).month == 1) {
			GDT.getDataStore("FSMPASTRACT").data.YPB = parseInt(GameManager.company.cash);
			GDT.getDataStore("FSMPASTRACT").data.YP = GDT.getDataStore("FSMPASTRACT").data.YPB - GDT.getDataStore("FSMPASTRACT").data.YPA;
			if (GDT.getDataStore("FSMPASTRACT").data.ASS > 0 && GDT.getDataStore("FSMPASTRACT").data.YP > 0) {
					var yy = GDT.getDataStore("FSMPASTRACT").data.YP * 0.2;
					GameManager.company.adjustCash(-yy, "Dividend payout");
			}
		}
	}	
	GDT.on(GDT.eventKeys.gameplay.weekProceeded, payDividend);
	
			/* Buy Securities */
	
	GDT.getDataStore("FSMPASTRACT").data.totalReturn = 0;
	
	var changeGoldPrice = function() {
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.goldPrice)) {
			GDT.getDataStore("FSMPASTRACT").data.goldPrice = 1000;
		}
		else if(GDT.getDataStore("FSMPASTRACT").data.goldPrice <= 1) {
			GDT.getDataStore("FSMPASTRACT").data.goldPrice = 10;
		}
		var i;
		var ee = [];
		for (var i = 12; i < 51; i++) {
			ee.push(i)
		}
		ff = ee.pickRandom();
		var hh = Math.random() * (1 - 0.5) + 0.5;
		if(ff < 25) {
			var gg = (1 - ff * hh / 1000)
			GDT.getDataStore("FSMPASTRACT").data.goldPrice *= gg
		}
		else {
			var gg = (1 + (ff - 25) * hh / 1000)
			GDT.getDataStore("FSMPASTRACT").data.goldPrice *= gg
		}
		$("#FS_BuySecurities_GoldPrice").html((GDT.getDataStore("FSMPASTRACT").data.goldPrice).toFixed(2));
		$("#FS_BuySecurities_GoldGrowth").html(((gg - 1) * 100).toFixed(1) + "%");
	}
	GDT.on(GDT.eventKeys.gameplay.weekProceeded, changeGoldPrice);
	
	var changeSilverPrice = function() {
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.silverPrice)) {
			GDT.getDataStore("FSMPASTRACT").data.silverPrice = 10;
		}
		else if(GDT.getDataStore("FSMPASTRACT").data.silverPrice <= 1) {
			GDT.getDataStore("FSMPASTRACT").data.silverPrice = 1;
		}
		var zz;
		var ee = [];
		for (var zz = 8; zz < 51; zz++) {
			ee.push(zz)
		}
		ff = ee.pickRandom();
		var hh = Math.random() * (1 - 0.5) + 0.5;
		if(ff < 25) {
			var gg = (1 - ff * hh / 1000)
			GDT.getDataStore("FSMPASTRACT").data.silverPrice *= gg
		}
		else {
			var gg = (1 + (ff - 25) * hh / 1000)
			GDT.getDataStore("FSMPASTRACT").data.silverPrice *= gg
		}
		$("#FS_BuySecurities_SilverPrice").html((GDT.getDataStore("FSMPASTRACT").data.silverPrice).toFixed(2));
		$("#FS_BuySecurities_SilverGrowth").html(((gg - 1) * 100).toFixed(1) + "%");
	}
	GDT.on(GDT.eventKeys.gameplay.weekProceeded, changeSilverPrice);
	
	var changeOilPrice = function() {
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.oilPrice)) {
			GDT.getDataStore("FSMPASTRACT").data.oilPrice = 50;
		}
		else if(GDT.getDataStore("FSMPASTRACT").data.oilPrice <= 1) {
			GDT.getDataStore("FSMPASTRACT").data.oilPrice = 5;
		}
		var xx;
		var nn = [];
		for (var xx = 10; xx < 81; xx++) {
			nn.push(xx)
		}
		ff = nn.pickRandom();
		var hh = Math.random() * (1 - 0.5) + 0.5;
		if(ff < 40) {
			var gg = (1 - ff * hh / 1000)
			GDT.getDataStore("FSMPASTRACT").data.oilPrice *= gg
		}
		else {
			var gg = (1 + (ff - 50) * hh / 1000)
			GDT.getDataStore("FSMPASTRACT").data.oilPrice *= gg
		}
		$("#FS_BuySecurities_OilPrice").html((GDT.getDataStore("FSMPASTRACT").data.oilPrice).toFixed(2));
		$("#FS_BuySecurities_OilGrowth").html(((gg - 1) * 100).toFixed(1) + "%");
	}
	GDT.on(GDT.eventKeys.gameplay.weekProceeded, changeOilPrice);
	
	var changeNSEPrice = function() {
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.NSEPrice)) {
			GDT.getDataStore("FSMPASTRACT").data.NSEPrice = 300;
		}
		else if(GDT.getDataStore("FSMPASTRACT").data.NSEPrice <= 1) {
			GDT.getDataStore("FSMPASTRACT").data.NSEPrice = 15;
		}
		var uu;
		var oo = [];
		for (var uu = 20; uu < 101; uu++) {
			oo.push(uu)
		}
		ff = oo.pickRandom();
		var hh = Math.random() * (1 - 0.5) + 0.5;
		if(ff < 50) {
			var gg = (1 - ff * hh / 1000)
			GDT.getDataStore("FSMPASTRACT").data.NSEPrice *= gg
		}
		else {
			var gg = (1 + (ff - 50) * hh / 1000)
			GDT.getDataStore("FSMPASTRACT").data.NSEPrice *= gg
		}
		$("#FS_BuySecurities_NSEPrice").html((GDT.getDataStore("FSMPASTRACT").data.NSEPrice).toFixed(2));
		$("#FS_BuySecurities_NSEGrowth").html(((gg - 1) * 100).toFixed(1) + "%");
	}
	GDT.on(GDT.eventKeys.gameplay.weekProceeded, changeNSEPrice);
	
	var buyGold = function() {
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.goldAmount)) {
			GDT.getDataStore("FSMPASTRACT").data.goldAmount = 0;
		}
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.goldValue)) {
			GDT.getDataStore("FSMPASTRACT").data.goldValue = 0;
		}
		
		var ii = Math.ceil(parseInt($("#FS_BuySecurities_GoldInputField").val()));
		if (ii <= 0 || isNaN(ii)) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("Please enter a valid number (higher than 0).");
		}
		else if(ii > GameManager.company.cash) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You do not have the sufficient funds for this transaction.");
		}
		else {
			$("#FS_Main").dialog('close');
			GDT.getDataStore("FSMPASTRACT").data.goldAmount += ii
			GDT.getDataStore("FSMPASTRACT").data.goldValue += (ii * GDT.getDataStore("FSMPASTRACT").data.goldPrice);
			GameManager.company.adjustCash(-(ii * GDT.getDataStore("FSMPASTRACT").data.goldPrice), "GLD ETF Transaction");
		}
	}
	
	var sellGold = function() {
		var jj = Math.ceil(parseInt($("#FS_BuySecurities_GoldInputField").val()));
		if (jj <= 0 || isNaN(jj)) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("Please enter a valid number (higher than 0).");
		}
		else if(jj > GDT.getDataStore("FSMPASTRACT").data.goldAmount) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You do not have this much ETFs in your portfolio to sell.");
		}
		else {
			$("#FS_Main").dialog('close');
			GDT.getDataStore("FSMPASTRACT").data.goldAmount -= jj
			GDT.getDataStore("FSMPASTRACT").data.goldValue -= (jj * GDT.getDataStore("FSMPASTRACT").data.goldPrice);
			GameManager.company.adjustCash(jj * GDT.getDataStore("FSMPASTRACT").data.goldPrice, "GLD ETF Transaction");
		}
	}
	
	var buySilver = function() {
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.silverAmount)) {
			GDT.getDataStore("FSMPASTRACT").data.silverAmount = 0;
		}
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.silverValue)) {
			GDT.getDataStore("FSMPASTRACT").data.silverValue = 0;
		}
		var kk = Math.ceil(parseInt($("#FS_BuySecurities_SilverInputField").val()));
		if (kk <= 0 || isNaN(kk)) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("Please enter a valid number (higher than 0).");
		}
		else if(kk > GameManager.company.cash) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You do not have the sufficient funds for this transaction.");
		}
		else {
			$("#FS_Main").dialog('close');
			GDT.getDataStore("FSMPASTRACT").data.silverAmount += kk
			GDT.getDataStore("FSMPASTRACT").data.silverValue += (kk * GDT.getDataStore("FSMPASTRACT").data.silverPrice);
			GameManager.company.adjustCash(-(kk * GDT.getDataStore("FSMPASTRACT").data.silverPrice), "SLV ETF Transaction");
		}
	}
	
	var sellSilver = function() {
		var mm = Math.ceil(parseInt($("#FS_BuySecurities_SilverInputField").val()));
		if (mm <= 0 || isNaN(mm)) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("Please enter a valid number (higher than 0).");
		}
		else if(mm > GDT.getDataStore("FSMPASTRACT").data.silverAmount) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You do not have this much ETFs in your portfolio to sell.");
		}
		else {
			$("#FS_Main").dialog('close');
			GDT.getDataStore("FSMPASTRACT").data.silverAmount -= mm
			GDT.getDataStore("FSMPASTRACT").data.silverValue -= (mm * GDT.getDataStore("FSMPASTRACT").data.silverPrice);
			GameManager.company.adjustCash(mm * GDT.getDataStore("FSMPASTRACT").data.silverPrice, "SLV ETF Transaction");
		}
	}
	var buyOil = function() {
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.oilAmount)) {
			GDT.getDataStore("FSMPASTRACT").data.oilAmount = 0;
		}
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.oilValue)) {
			GDT.getDataStore("FSMPASTRACT").data.oilValue = 0;
		}
		
		var kk = Math.ceil(parseInt($("#FS_BuySecurities_OilInputField").val()));
		if (kk <= 0 || isNaN(kk)) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("Please enter a valid number (higher than 0).");
		}
		else if(kk > GameManager.company.cash) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You do not have the sufficient funds for this transaction.");
		}
		else {
			$("#FS_Main").dialog('close');
			GDT.getDataStore("FSMPASTRACT").data.oilAmount += kk
			GDT.getDataStore("FSMPASTRACT").data.oilValue += (kk * GDT.getDataStore("FSMPASTRACT").data.oilPrice)
			GameManager.company.adjustCash(-(kk * GDT.getDataStore("FSMPASTRACT").data.oilPrice), "OIL ETF Transaction");
		}
	}
	
	var sellOil = function() {
		var mm = Math.ceil(parseInt($("#FS_BuySecurities_OilInputField").val()));
		if (mm <= 0 || isNaN(mm)) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("Please enter a valid number (higher than 0).");
		}
		else if(mm > GDT.getDataStore("FSMPASTRACT").data.oilAmount) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You do not have this much ETFs in your portfolio to sell.");
		}
		else {
			$("#FS_Main").dialog('close');
			GDT.getDataStore("FSMPASTRACT").data.oilAmount -= mm
			GDT.getDataStore("FSMPASTRACT").data.oilValue -= (mm * GDT.getDataStore("FSMPASTRACT").data.oilPrice)
			GameManager.company.adjustCash(mm * GDT.getDataStore("FSMPASTRACT").data.oilPrice, "OIL ETF Transaction");
		}
	}
	
	var buyNSE = function() {
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.NSEAmount)) {
			GDT.getDataStore("FSMPASTRACT").data.NSEAmount = 0;
		}
		if(isNaN(GDT.getDataStore("FSMPASTRACT").data.NSEValue)) {
			GDT.getDataStore("FSMPASTRACT").data.NSEValue = 0;
		}
		
		var kk = Math.ceil(parseInt($("#FS_BuySecurities_NSEInputField").val()));
		if (kk <= 0 || isNaN(kk)) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("Please enter a valid number (higher than 0).");
		}
		else if(kk > GameManager.company.cash) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You do not have the sufficient funds for this transaction.");
		}
		else {
			$("#FS_Main").dialog('close');
			GDT.getDataStore("FSMPASTRACT").data.NSEAmount += kk
			GDT.getDataStore("FSMPASTRACT").data.NSEValue += (kk * GDT.getDataStore("FSMPASTRACT").data.NSEPrice);
			GameManager.company.adjustCash(-(kk * GDT.getDataStore("FSMPASTRACT").data.NSEPrice), "NSE ETF Transaction");
		}
	}
	
	var sellNSE = function() {
		var mm = Math.ceil(parseInt($("#FS_BuySecurities_NSEInputField").val()));
		if (mm <= 0 || isNaN(mm)) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("Please enter a valid number (higher than 0).");
		}
		else if(mm > GDT.getDataStore("FSMPASTRACT").data.NSEAmount) {
			$("#FS_Error").gdDialog({
					popout: true,
					close: true
			});
			$("#FS_Error_Title").html("Error");
			$("#FS_Error_Text").html("You do not have this much ETFs in your portfolio to sell.");
		}
		else {
			$("#FS_Main").dialog('close');
			GDT.getDataStore("FSMPASTRACT").data.NSEAmount -= mm
			GDT.getDataStore("FSMPASTRACT").data.NSEValue -= (mm * GDT.getDataStore("FSMPASTRACT").data.NSEPrice);
			GameManager.company.adjustCash(mm * GDT.getDataStore("FSMPASTRACT").data.NSEPrice, "NSE ETF Transaction");
		}
	}
	
	var displaySecuritiesInformation = function() {
		$("#FS_InformationScreen").gdDialog({
			popout: true,
			close: true,
		});
		$("#FS_Information_Text").html("By buying securities you are able to raise funds by buying securities at a low price and selling once the price is higher. However, this does not go without risk: the price is not guaranteed to rise and therefore you could loose a lot of money. The prices fluctuate randomly every week.<br><br>Abbreviations:<ul><li><strong>ETF:</strong> ETFs are financial products that track the value of the underlying asset. For example: by buying an ETF for gold, you are not buying the gold commodity itself, but the financial product that has the same value as gold and fluctuates the same.</li><li><strong>GLD:</strong> Gold</li><li><strong>SLV:</strong> Silver</li><li><strong>OIL:</strong> Brent Oil</li><li><strong>NSE:</strong> National Stock Exchange Index</li></ul><br>In the portfolio screen you can view all the investments you currently posses, as well as the return (= profit) of the investments. ");
	};
	
	var displaySecuritiesPortfolio = function() {
		$("#FS_PortfolioScreen").gdDialog({
			popout: true,
			close: true,
		});
	};
	
	var displayPortfolioGold = function() {
		if (GDT.getDataStore("FSMPASTRACT").data.goldAmount <= 0 || isNaN(GDT.getDataStore("FSMPASTRACT").data.goldAmount)) {
			var goldReturn = 0;
			GDT.getDataStore("FSMPASTRACT").data.goldAmount = 0;
		}
		else {
			var goldReturn = GDT.getDataStore("FSMPASTRACT").data.goldAmount * GDT.getDataStore("FSMPASTRACT").data.goldPrice - GDT.getDataStore("FSMPASTRACT").data.goldValue;
		}
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.totalReturn)) {
			GDT.getDataStore("FSMPASTRACT").data.goldReturn = 0;
		}
		GDT.getDataStore("FSMPASTRACT").data.goldReturn = goldReturn;
		if ((goldReturn >= 1E3 && goldReturn < 1E6) || (goldReturn <= -1E3 && goldReturn > -1E6)) {
			$("#FS_PortfolioScreen_GoldReturn").html((goldReturn / 1E3).toFixed(1) + "K ");
		}
		else if ((goldReturn >= 1E6 && goldReturn < 1E9) || (goldReturn <= -1E6 && goldReturn > -1E9)) {
			$("#FS_PortfolioScreen_GoldReturn").html((goldReturn / 1E6).toFixed(1) + "M ");
		}
		else if (goldReturn >= 1E9 || goldReturn <= -1E9) {
			$("#FS_PortfolioScreen_GoldReturn").html((goldReturn / 1E9).toFixed(1) + "B ");
		}
		else {
			$("#FS_PortfolioScreen_GoldReturn").html(goldReturn.toFixed(2) + " ");
		}
		$("#FS_PortfolioScreen_GoldAmount").html(GDT.getDataStore("FSMPASTRACT").data.goldAmount + " ");
	}
	
	var displayPortfolioSilver = function() {
		if (GDT.getDataStore("FSMPASTRACT").data.silverAmount <= 0 || isNaN(GDT.getDataStore("FSMPASTRACT").data.silverAmount)) {
			var silverReturn = 0;
			GDT.getDataStore("FSMPASTRACT").data.silverAmount = 0;
		}
		else {
			var silverReturn = GDT.getDataStore("FSMPASTRACT").data.silverAmount * GDT.getDataStore("FSMPASTRACT").data.silverPrice - GDT.getDataStore("FSMPASTRACT").data.silverValue;
		}
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.silverReturn)) {
			GDT.getDataStore("FSMPASTRACT").data.silverReturn = 0;
		}
		GDT.getDataStore("FSMPASTRACT").data.silverReturn = silverReturn;
		if ((silverReturn >= 1E3 && silverReturn < 1E6) || (silverReturn <= -1E3 && silverReturn > -1E6)) {
			$("#FS_PortfolioScreen_SilverReturn").html((silverReturn / 1E3).toFixed(1) + "K ");
		}
		else if ((silverReturn >= 1E6 && silverReturn < 1E9) || (silverReturn <= -1E6 && silverReturn > -1E9)) {
			$("#FS_PortfolioScreen_SilverReturn").html((silverReturn / 1E6).toFixed(1) + "M ");
		}
		else if (silverReturn >= 1E9 || silverReturn <= -1E9) {
			$("#FS_PortfolioScreen_SilverReturn").html((silverReturn / 1E9).toFixed(1) + "B ");
		}
		else {
			$("#FS_PortfolioScreen_SilverReturn").html(silverReturn.toFixed(2) + " ");
		}
		$("#FS_PortfolioScreen_SilverAmount").html(GDT.getDataStore("FSMPASTRACT").data.silverAmount + " ");
	}
	
	var displayPortfolioOil = function() {
		if (GDT.getDataStore("FSMPASTRACT").data.oilAmount <= 0 || isNaN(GDT.getDataStore("FSMPASTRACT").data.oilAmount)) {
			var oilReturn = 0;
			GDT.getDataStore("FSMPASTRACT").data.oilAmount = 0;
		}
		else {
			var oilReturn = GDT.getDataStore("FSMPASTRACT").data.oilAmount * GDT.getDataStore("FSMPASTRACT").data.oilPrice - GDT.getDataStore("FSMPASTRACT").data.oilValue;
		}
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.oilReturn)) {
			GDT.getDataStore("FSMPASTRACT").data.oilReturn = 0;
		}
		GDT.getDataStore("FSMPASTRACT").data.oilReturn = oilReturn;
		if ((oilReturn >= 1E3 && oilReturn < 1E6) || (oilReturn <= -1E3 && oilReturn > -1E6)) {
			$("#FS_PortfolioScreen_OilReturn").html((oilReturn / 1E3).toFixed(1) + "K ");
		}
		else if ((oilReturn >= 1E6 && oilReturn < 1E9) || (oilReturn <= -1E6 && oilReturn > -1E9)) {
			$("#FS_PortfolioScreen_OilReturn").html((oilReturn / 1E6).toFixed(1) + "M ");
		}
		else if (oilReturn >= 1E9 || oilReturn <= -1E9) {
			$("#FS_PortfolioScreen_OilReturn").html((oilReturn / 1E9).toFixed(1) + "B ");
		}
		else {
			$("#FS_PortfolioScreen_OilReturn").html(oilReturn.toFixed(2) + " ");
		}
		$("#FS_PortfolioScreen_OilAmount").html(GDT.getDataStore("FSMPASTRACT").data.oilAmount + " ");
	}
	
	var displayPortfolioNSE = function() {
		if (GDT.getDataStore("FSMPASTRACT").data.NSEAmount <= 0 || isNaN(GDT.getDataStore("FSMPASTRACT").data.NSEAmount)) {
			var NSEReturn = 0;
			GDT.getDataStore("FSMPASTRACT").data.NSEAmount = 0;
		}
		else {
			var NSEReturn = GDT.getDataStore("FSMPASTRACT").data.NSEAmount * GDT.getDataStore("FSMPASTRACT").data.NSEPrice - GDT.getDataStore("FSMPASTRACT").data.NSEValue;
		}
		if (isNaN(GDT.getDataStore("FSMPASTRACT").data.NSEReturn)) {
			GDT.getDataStore("FSMPASTRACT").data.NSEReturn = 0;
		}
		GDT.getDataStore("FSMPASTRACT").data.NSEReturn = NSEReturn;
		if ((NSEReturn >= 1E3 && NSEReturn < 1E6) || (NSEReturn <= -1E3 && NSEReturn > -1E6)) {
			$("#FS_PortfolioScreen_NSEReturn").html((NSEReturn / 1E3).toFixed(1) + "K ");
		}
		else if ((NSEReturn >= 1E6 && NSEReturn < 1E9) || (NSEReturn <= -1E6 && NSEReturn > -1E9)) {
			$("#FS_PortfolioScreen_NSEReturn").html((NSEReturn / 1E6).toFixed(1) + "M ");
		}
		else if (NSEReturn >= 1E9 || NSEReturn <= -1E9) {
			$("#FS_PortfolioScreen_NSEReturn").html((NSEReturn / 1E9).toFixed(1) + "B ");
		}
		else {
			$("#FS_PortfolioScreen_NSEReturn").html(NSEReturn.toFixed(2) + " ");
		}
		$("#FS_PortfolioScreen_NSEAmount").html(GDT.getDataStore("FSMPASTRACT").data.NSEAmount + " ");
	}
	
	var displayPortfolioTotal = function() {
		var totalAmount = parseInt(GDT.getDataStore("FSMPASTRACT").data.NSEAmount) + parseInt(GDT.getDataStore("FSMPASTRACT").data.oilAmount) + parseInt(GDT.getDataStore("FSMPASTRACT").data.goldAmount) + parseInt(GDT.getDataStore("FSMPASTRACT").data.silverAmount);
		var totalReturn = parseInt(GDT.getDataStore("FSMPASTRACT").data.goldReturn + GDT.getDataStore("FSMPASTRACT").data.silverReturn + GDT.getDataStore("FSMPASTRACT").data.oilReturn + GDT.getDataStore("FSMPASTRACT").data.NSEReturn);
		if ((totalReturn >= 1E3 && totalReturn < 1E6) || (totalReturn <= -1E3 && totalReturn > -1E6)) {
			$("#FS_PortfolioScreen_TotalReturn").html("<strong>" + (totalReturn / 1E3).toFixed(1) + "K </strong>");
		}
		else if ((totalReturn >= 1E6 && totalReturn < 1E9) || (totalReturn <= -1E6 && totalReturn > -1E9)) {
			$("#FS_PortfolioScreen_TotalReturn").html("<strong>" + (totalReturn / 1E6).toFixed(1) + "M </strong>");
		}
		else if (totalReturn >= 1E9 || totalReturn <= -1E9) {
			$("#FS_PortfolioScreen_TotalReturn").html("<strong>" + (totalReturn / 1E9).toFixed(1) + "B </strong>");
		}
		else {
			$("#FS_PortfolioScreen_TotalReturn").html("<strong>" + totalReturn.toFixed(2) + "</strong>");
		}
		$("#FS_PortfolioScreen_TotalAmount").html("<strong>" + totalAmount + " </strong>");
	}

})();		